/***************************************************************************
                          ckohonensynapse.cpp  -  description
                             -------------------
    begin                : Thu Feb 15 2001
    copyright            : (C) 2001 by Jon Hennig
    email                : jon.hennig@gmx.net
 ***************************************************************************/
 /***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "ckohonensynapse.h"


CKohonenSynapse::CKohonenSynapse(CNeuron* pre_neuron, CNeuron* post_neuron, TNSynapticWeight a_weight)
:CSynapse(pre_neuron,post_neuron,a_weight)
{
}

/** die einzige Funktion, die im Prinzip verndert werden muss.
als Ergebnis wird der Betrag der Differenz zwischen in und Output zurckgeliefert*/
TNPostSynapticValue CKohonenSynapse::get_post_synaptic_value(TNPreSynapticValue a_input)
{
	return fabs(a_input-weight);
}

/** liefert den letzen Input fr diese Synapse
  * das entspricht den letzten Output des Vorgngerneurons
  * ACHTUNG!! Das widerspricht etwas dem lokalen Charakter der brigen
  * Implementierung. Es sollte daher sichergestellt sein, dass zum Zeitpunkt
  * der Abfrage die vorhergehenden Neuronen die gleichen Werte haben
  * wie zum Zeitpunkt der Erregung der Synapse*/
TNPreSynapticValue CKohonenSynapse::get_last_input()
{
	return pre_synaptic_neuron->get_last_output();
}

